//+------------------------------------------------------------------+
//|                                                ControlErrors.mqh |
//|                                             Copyright KlimMalgin |
//|     :                       |
//| MetaTrader 5/MQL5/Include/                                       |
//+------------------------------------------------------------------+
#property copyright "KlimMalgin"
#property link      ""



class ControlErrors
{
private:

   // , ,     
   bool _PlaySound;    //         .
   bool _PrintInfo;    //       
   bool _AlertInfo;    //  Alert c   
   bool _WriteFile;    //        
   
   //        ,   
   struct Code
   {
      int code;      //  
      string desc;   //   
   };
   Code Errors[];    // ,      
   Code _UserError;  //     
   Code _Error;      //          
   
   //   
   short  _CountErrors;     //  ,    Errors[]
   string _PlaySoundFile;   // ,      
   string _DataPath;        //      

   
public:
   // 
   ControlErrors(void);
   
   //    
   void SetSound(bool value);          //        
   void SetPrint(bool value);          //         
   void SetAlert(bool value);          //   Alert  
   void SetWriteFlag(bool flag);       //   . true -  , false -  
   
   //     
   int  mGetLastError();            //     _LastError
   int  mGetError();                //     
   int  mGetTypeError();            //    ( = 1   = 0)
   void mResetLastError();          //     _LastError
   void mSetUserError(ushort value, string desc = "");   //   
   void mResetUserError();          //   ,     
   void mResetError();              //  ,     
   string mGetDesc(int nErr = 0);   //     ,  ,    
   int Check(string st = "");       //         
   
   //  (Alert, Print, Sound)
   void mAlert(string message = "");
   void mPrint(string message = "");
   void mSound();
      
   //   
   void SetPlaySoundFile(string file); //        
   void SetWritePath(string path);     //        
   int mFileWrite(string message = "");//        
};

void ControlErrors::ControlErrors(void)
{
   SetAlert(false);
   SetPrint(false);
   SetSound(false);
   SetWriteFlag(false);
   SetPlaySoundFile("alert.wav");
   SetWritePath("LogErrors.txt"); 
   
   _CountErrors = 150;

   ArrayResize(Errors, _CountErrors);
   //    
   Errors[0].code = 10004;Errors[0].desc = "";
   Errors[1].code = 10006;Errors[1].desc = " ";
   Errors[2].code = 10007;Errors[2].desc = "  ";
   Errors[3].code = 10008;Errors[3].desc = " ";
   Errors[4].code = 10009;Errors[4].desc = " ";
   Errors[5].code = 10010;Errors[5].desc = "  ";
   Errors[6].code = 10011;Errors[6].desc = "  ";
   Errors[7].code = 10012;Errors[7].desc = "    ";
   Errors[8].code = 10013;Errors[8].desc = " ";
   Errors[9].code = 10014;Errors[9].desc = "   ";
   Errors[10].code = 10015;Errors[10].desc = "   ";
   Errors[11].code = 10016;Errors[11].desc = "   ";
   Errors[12].code = 10017;Errors[12].desc = " ";
   Errors[13].code = 10018;Errors[13].desc = " ";
   Errors[14].code = 10019;Errors[14].desc = "      ";
   Errors[15].code = 10020;Errors[15].desc = " ";
   Errors[16].code = 10021;Errors[16].desc = "    ";
   Errors[17].code = 10022;Errors[17].desc = "     ";
   Errors[18].code = 10023;Errors[18].desc = "  ";
   Errors[19].code = 10024;Errors[19].desc = "  ";
   Errors[20].code = 10025;Errors[20].desc = "   ";
   Errors[21].code = 10026;Errors[21].desc = "  ";
   Errors[22].code = 10027;Errors[22].desc = "   ";
   Errors[23].code = 10028;Errors[23].desc = "   ";
   Errors[24].code = 10029;Errors[24].desc = "   ";
   Errors[25].code = 10030;Errors[25].desc = "      ";

   //  
   Errors[26].code = 4001;Errors[26].desc = "  ";
   Errors[27].code = 4002;Errors[27].desc = "       ";
   Errors[28].code = 4003;Errors[28].desc = "     ";
   Errors[29].code = 4004;Errors[29].desc = "     ";
   Errors[30].code = 4005;Errors[30].desc = "    /   /     / ";
   Errors[31].code = 4006;Errors[31].desc = "  ,       ";
   Errors[32].code = 4007;Errors[32].desc = "          ";
   Errors[33].code = 4008;Errors[33].desc = "    ";
   Errors[34].code = 4009;Errors[34].desc = " ";
   Errors[35].code = 4010;Errors[35].desc = "   / ";
   Errors[36].code = 4011;Errors[36].desc = "    2 ";
   Errors[37].code = 4012;Errors[37].desc = " ";
   Errors[38].code = 4013;Errors[38].desc = "  ";
   Errors[39].code = 4014;Errors[39].desc = "     ";

   // 
   Errors[40].code = 4101;Errors[40].desc = "  ";
   Errors[41].code = 4102;Errors[41].desc = "  ";
   Errors[42].code = 4103;Errors[42].desc = "  ";
   Errors[43].code = 4104;Errors[43].desc = "   ,     ";
   Errors[44].code = 4105;Errors[44].desc = "  ";
   Errors[45].code = 4106;Errors[45].desc = "       ";
   Errors[46].code = 4107;Errors[46].desc = "   ";
   Errors[47].code = 4108;Errors[47].desc = "   ";
   Errors[48].code = 4109;Errors[48].desc = "   ";
   Errors[49].code = 4110;Errors[49].desc = "   ";
   Errors[50].code = 4111;Errors[50].desc = "   ";
   Errors[51].code = 4112;Errors[51].desc = "   ";
   Errors[52].code = 4113;Errors[52].desc = ",   ,  ";

   //  
   Errors[53].code = 4201;Errors[53].desc = "     ";
   Errors[54].code = 4202;Errors[54].desc = "   ";
   Errors[55].code = 4203;Errors[55].desc = "    ";
   Errors[56].code = 4204;Errors[56].desc = "  ,  ";
   Errors[57].code = 4205;Errors[57].desc = "  ,  ";
   
   // MarketInfo   
   Errors[58].code = 4301;Errors[58].desc = " ";
   Errors[59].code = 4302;Errors[59].desc = "    MarketWatch";
   Errors[60].code = 4303;Errors[60].desc = "   ";
   Errors[61].code = 4304;Errors[61].desc = "    (  )";
   
   //   
   Errors[62].code = 4401;Errors[62].desc = "   ";
   Errors[63].code = 4402;Errors[63].desc = "   ";
   
   // Global_Variables
   Errors[64].code = 4501;Errors[64].desc = "     ";
   Errors[65].code = 4502;Errors[65].desc = "        ";
   Errors[66].code = 4510;Errors[66].desc = "   ";
   Errors[67].code = 4511;Errors[67].desc = "   ";
   Errors[68].code = 4512;Errors[68].desc = "   ";
   Errors[69].code = 4513;Errors[69].desc = "   ";
   Errors[70].code = 4514;Errors[70].desc = "     ftp";
   
   //   
   Errors[71].code = 4601;Errors[71].desc = "     ";
   Errors[72].code = 4602;Errors[72].desc = "    ";
   
   //   
   Errors[73].code = 4603;Errors[73].desc = "    ";
   
   // Account
   Errors[74].code = 4701;Errors[74].desc = "   ";
   Errors[75].code = 4751;Errors[75].desc = "   ";
   Errors[76].code = 4752;Errors[76].desc = "   ";
   Errors[77].code = 4753;Errors[77].desc = "  ";
   Errors[78].code = 4754;Errors[78].desc = "  ";
   Errors[79].code = 4755;Errors[79].desc = "  ";
   Errors[80].code = 4756;Errors[80].desc = "    ";
   Errors[81].code = 4757;Errors[81].desc = "    ()  ";
   
   // 
   Errors[82].code = 4801;Errors[82].desc = " ";
   Errors[83].code = 4802;Errors[83].desc = "    ";
   Errors[84].code = 4803;Errors[84].desc = "    ";
   Errors[85].code = 4804;Errors[85].desc = "       ";
   Errors[86].code = 4805;Errors[86].desc = "   ";
   Errors[87].code = 4806;Errors[87].desc = "   ";
   Errors[88].code = 4807;Errors[88].desc = "    ";
   Errors[89].code = 4808;Errors[89].desc = "     ";
   Errors[90].code = 4809;Errors[90].desc = "    ";
   Errors[91].code = 4810;Errors[91].desc = "        ";
   Errors[92].code = 4811;Errors[92].desc = "       ";
   
   //  
   Errors[93].code = 4901;Errors[93].desc = "     ";
   Errors[94].code = 4902;Errors[94].desc = "     ";
   Errors[95].code = 4903;Errors[95].desc = "      ";
   Errors[96].code = 4904;Errors[96].desc = "        ";
   
   //  
   Errors[97].code = 5001;Errors[97].desc = "      64 ";
   Errors[98].code = 5002;Errors[98].desc = "  ";
   Errors[99].code = 5003;Errors[99].desc = "   ";
   Errors[100].code = 5004;Errors[100].desc = "  ";
   Errors[101].code = 5005;Errors[101].desc = "    ";
   Errors[102].code = 5006;Errors[102].desc = "  ";
   Errors[103].code = 5007;Errors[103].desc = "      ,    ";
   Errors[104].code = 5008;Errors[104].desc = "  ";
   Errors[105].code = 5009;Errors[105].desc = "     ";
   Errors[106].code = 5010;Errors[106].desc = "     ";
   Errors[107].code = 5011;Errors[107].desc = "     ";
   Errors[108].code = 5012;Errors[108].desc = "     ";
   Errors[109].code = 5013;Errors[109].desc = "       CSV";
   Errors[110].code = 5014;Errors[110].desc = "     CSV";
   Errors[111].code = 5015;Errors[111].desc = "  ";
   Errors[112].code = 5016;Errors[112].desc = "    ,      ";
   Errors[113].code = 5017;Errors[113].desc = "      ,    ";
   Errors[114].code = 5018;Errors[114].desc = "  ,  ";
   Errors[115].code = 5019;Errors[115].desc = "  ";
   Errors[116].code = 5020;Errors[116].desc = "    ";
   Errors[117].code = 5021;Errors[117].desc = "  ";
   Errors[118].code = 5022;Errors[118].desc = "  ";
   Errors[119].code = 5023;Errors[119].desc = " ,   ";
   Errors[120].code = 5024;Errors[120].desc = "    ";
   
   //  
   Errors[121].code = 5030;Errors[121].desc = "   ";
   Errors[122].code = 5031;Errors[122].desc = "   ";
   Errors[123].code = 5032;Errors[123].desc = "   ";
   Errors[124].code = 5033;Errors[124].desc = "    ";
   Errors[125].code = 5034;Errors[125].desc = "   ";
   Errors[126].code = 5035;Errors[126].desc = "  ,  ";
   Errors[127].code = 5036;Errors[127].desc = "  , ,  ULONG_MAX";
   Errors[128].code = 5037;Errors[128].desc = "  ";
   Errors[129].code = 5038;Errors[129].desc = "  ,  ";
   Errors[130].code = 5039;Errors[130].desc = " ,   ";
   Errors[131].code = 5040;Errors[131].desc = "   string";
   Errors[132].code = 5041;Errors[132].desc = "   ";
   Errors[133].code = 5042;Errors[133].desc = "    0,  ";
   Errors[134].code = 5043;Errors[134].desc = "      ";
   Errors[135].code = 5044;Errors[135].desc = "  ";
   
   //   
   Errors[136].code = 5050;Errors[136].desc = "  .        ,      ";
   Errors[137].code = 5051;Errors[137].desc = "    AS_SERIES,    ";
   Errors[138].code = 5052;Errors[138].desc = "  ,     ";
   Errors[139].code = 5053;Errors[139].desc = "  ";
   Errors[140].code = 5054;Errors[140].desc = "   ";
   Errors[141].code = 5055;Errors[141].desc = "   ";
   Errors[142].code = 5056;Errors[142].desc = "    ";
   Errors[143].code = 5057;Errors[143].desc = "    double";
   Errors[144].code = 5058;Errors[144].desc = "    float";
   Errors[145].code = 5059;Errors[145].desc = "    long";
   Errors[146].code = 5060;Errors[146].desc = "    int";
   Errors[147].code = 5061;Errors[147].desc = "    short";
   Errors[148].code = 5062;Errors[148].desc = "    char";
}

void ControlErrors::SetAlert(bool value)
{
   _AlertInfo = value;
}

void ControlErrors::SetPrint(bool value)
{
   _PrintInfo = value;
}

void ControlErrors::SetSound(bool value)
{
   _PlaySound = value;
}

void ControlErrors::SetWriteFlag(bool flag)
{
   _WriteFile = flag;
}

void ControlErrors::SetWritePath(string path)
{
   _DataPath = path;
}

void ControlErrors::SetPlaySoundFile(string file)
{
   _PlaySoundFile = file;
}

int ControlErrors::mGetLastError(void)
{
   _Error.code = GetLastError();
   _Error.desc = mGetDesc(_Error.code);
   return _Error.code;
}

void ControlErrors::mResetLastError(void)
{
   ResetLastError();
}

int ControlErrors::mGetError(void)
{
   return _Error.code;
}

void ControlErrors::mResetError(void)
{
   _Error.code = 0;
   _Error.desc = "";
}

int ControlErrors::mGetTypeError(void)
{
   if (mGetError() < ERR_USER_ERROR_FIRST)
   {
      return 0;
   }
   else if (mGetError() >= ERR_USER_ERROR_FIRST)
   {
      return 1;
   }
   return -1;
}

void ControlErrors::mSetUserError(ushort value, string desc = "")
{
   SetUserError(value);
   _UserError.code = value;
   _UserError.desc = desc;
}

void ControlErrors::mResetUserError(void)
{
   _UserError.code = 0;
   _UserError.desc = "";
}

string ControlErrors::mGetDesc(int nErr=0)
{
   int ErrorNumber = 0;
   string ReturnDesc = "";
   
   ErrorNumber = (mGetError()>0)?mGetError():ErrorNumber;
   ErrorNumber = (nErr>0)?nErr:ErrorNumber;
   
   if ((ErrorNumber > 0) && (ErrorNumber < ERR_USER_ERROR_FIRST))
   {
      for (int i = 0;i<_CountErrors;i++)
      {
         if (Errors[i].code == ErrorNumber)
         {
            ReturnDesc = Errors[i].desc;
            break;
         }
      }
   }
   else if (ErrorNumber > ERR_USER_ERROR_FIRST)
   {
      ReturnDesc = (_UserError.desc=="")?" ":_UserError.desc;
   }
      
   if (ReturnDesc == ""){return "  : "+(string)ErrorNumber;}
   return ReturnDesc;
}

void ControlErrors::mAlert(string message="")
{
   if (_AlertInfo == true)
   {
      if (message == "")
      {
         if (mGetError() > 0)
         {
            Alert(" ",mGetError()," - ",mGetDesc());
         }
      }
      else
      {
         Alert(message);
      }   
   }
}

void ControlErrors::mPrint(string message="")
{
   if (_PrintInfo == true)
   {
      if (message == "")
      {
         if (mGetError() > 0)
         {
            Print(" ",mGetError()," - ",mGetDesc());
         }
      }
      else
      {
         Print(message);
      }
   }
}

void ControlErrors::mSound(void)
{
   if (_PlaySound == true)
   {
      PlaySound(_PlaySoundFile);
   }
}

int ControlErrors::Check(string st="")
{
   int errNum = 0;
   errNum = mGetLastError();
   mFileWrite();
   mAlert(st);
   mPrint(st);
   mSound();
   mResetError();
   mResetLastError();
   mResetUserError();
   return errNum;
}

int ControlErrors::mFileWrite(string message = "")
{
   int      handle  = 0,
            _return = 0;
   datetime time    = TimeCurrent();
   string   text    = (message != "")?message:time+" -  "+mGetError()+" "+mGetDesc();
   
   if (_WriteFile == true)
   {
      handle = FileOpen(_DataPath,FILE_READ|FILE_WRITE|FILE_TXT|FILE_ANSI);
      if (handle != INVALID_HANDLE)
      {
         ulong size = FileSize(handle);
         FileSeek(handle,size,SEEK_SET);
         _return = FileWrite(handle,text);
         FileClose(handle);
      }
   }
   return _return;
}


